# ----------------------------------------------------------------------------------------------------------------------
#
#   Test
#
# ----------------------------------------------------------------------------------------------------------------------
# Documentation
#   * Official
#     * https://docs.gitlab.com/ee/ci/yaml/
#     * https://docs.gitlab.com/ee/ci/variables/predefined_variables.html
#
#   * Japanese
#     * https://gitlab-docs.creationline.com/ee/ci/yaml/README.html
#
# Table of Contents
#   * pytest: https://github.com/pytest-dev/pytest
#   * pytest-cov: https://github.com/pytest-dev/pytest-cov
#
# ----------------------------------------------------------
#   pytest
# ----------------------------------------------------------
pytest:
  extends:
    - .requirements-packages
  stage: Test
  script:
    - pip3 install $(grep "pytest" ${REQUIREMENTS_TEST_TXT_PATH} | sed -z "s/\n/ /g")
    - coverage run -m pytest --all
    - coverage report
    - coverage xml
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

# ----------------------------------------------------------
#   Test Jupyter Notebook
# ----------------------------------------------------------
jupyter-notebook:
  extends:
    - .requirements-packages
  stage: Test
  script:
    - pip3 install "$(grep "notebook" ${REQUIREMENTS_TEST_TXT_PATH})"
    - pip3 install "$(grep "matplotlib" ${REQUIREMENTS_TEST_TXT_PATH})"
    - bash "${JUPYTER_TEST_SHELL_PATH}"
